<template>
  <div>
    <template v-if="inputParams.length > 0">
      <v-data-table
        :headers="inputHeaders"
        :items="inputParams"
        sort-by="orden"
        height="200"
        fixed-header
        hide-default-footer
        item-key="index"
      >
        <template v-slot:item.orden="{ item }">
          <v-text-field
            v-model.number.trim="item.orden"
            placeholder="Orden"
            type="number"
          ></v-text-field>
        </template>
        <template v-slot:item.name="{ item }">
          <v-text-field
            v-model.trim="item.name"
            placeholder="Nombre"
            disabled
            readonly
          ></v-text-field>
        </template>
        <template v-slot:item.value="{ item }">
          <v-text-field
            v-model.trim="item.value"
            placeholder="Valor"
          ></v-text-field>
        </template>
        <template v-slot:item.oracle_type="{ item }">
          <v-select
            v-model="item.oracle_type"
            :items="oracleTypesIn"
          ></v-select>
        </template>
        <template v-slot:top>
          <v-toolbar flat color="white">
            <v-toolbar-title>Parámetros de entrada</v-toolbar-title>
          </v-toolbar>
        </template>
        <template v-slot:item.delete="{ item }">
          <v-icon color="red" small @click="deleteInputParam(item)">
            mdi-delete
          </v-icon>
        </template>
        <template v-slot:no-data>
          Sin parámetros de entrada
        </template>
      </v-data-table>
    </template>
    <template v-if="outputParams.length > 0">
      <v-data-table
        :headers="outputHeaders"
        :items="outputParams"
        sort-by="orden"
        height="200"
        fixed-header
        hide-default-footer
        item-key="index"
      >
        <template v-slot:item.orden="{ item }">
          <v-text-field
            v-model.number.trim="item.orden"
            placeholder="Orden"
            type="number"
          ></v-text-field>
        </template>
        <template v-slot:item.name="{ item }">
          <v-text-field
            v-model.trim="item.name"
            placeholder="Nombre"
            disabled
            readonly
          ></v-text-field>
        </template>
        <template v-slot:item.oracle_type="{ item }">
          <v-select
            v-model="item.oracle_type"
            :items="oracleTypesOut"
          ></v-select>
        </template>
        <template v-slot:top>
          <v-toolbar flat color="white">
            <v-toolbar-title>Parámetros de salida</v-toolbar-title>
          </v-toolbar>
        </template>
        <template v-slot:item.delete="{ item }">
          <v-icon color="red" small @click="deleteOutputParam(item)">
            mdi-delete
          </v-icon>
        </template>
        <template v-slot:no-data>
          Sin parámetros de salida
        </template>
      </v-data-table>
    </template>
  </div>
</template>
<script>
export default {
  name: "Component-Params",
  props: {
    itemTab: Object,
  },
  data: () => ({
    outputHeaders: [
      {
        text: "Nombre",
        align: "start",
        sortable: false,
        value: "name",
      },
      { text: "Tipo de Dato", value: "oracle_type", sortable: false },
    ],
    inputHeaders: [
      {
        text: "Nombre",
        align: "start",
        sortable: false,
        value: "name",
      },
      { text: "Valor", value: "value", sortable: false },
      { text: "Tipo de Dato", value: "oracle_type", sortable: false },
    ],
    oracleTypesIn: ["VARCHAR", "NUMERIC", "DATE", "TIME", "TIMESTAMP"],
    oracleTypesOut: [
      "VARCHAR",
      "NUMERIC",
      "DATE",
      "TIME",
      "TIMESTAMP",
      "CURSOR",
    ],
    inputParams: [],
    outputParams: [],
    inoutParams: [],
    defaultOutputParam: {
      index: -1,
      orden: 0,
      name: "",
      type: "OUT",
      oracle_type: "VARCHAR",
    },
    defaultInputParam: {
      index: -1,
      orden: 0,
      name: "",
      value: "",
      type: "IN",
      oracle_type: "VARCHAR",
    },
  }),
  computed: {
    plsql() {
      return this.itemTab.plsql;
    },
    isDialogParams() {
      return this.itemTab.isDialogParams;
    },
  },
  watch: {
    inputParams: {
      deep: true,
      handler: function() {
        this.mergeParams();
      },
    },
    outputParams: {
      deep: true,
      handler: function() {
        this.mergeParams();
      },
    },
    isDialogParams: {
      deep: true,
      handler: function(value) {
        if (value) {
          this.extractParamsFromInput();
        } else {
          this.outputParams = [];
        }
      },
    },
  },
  methods: {
    extractParamsFromInput() {
      const value = this.plsql;
      const outMatch = /out:/g;
      const inMatch = /in:/g;
      const outIndexMatches = [];
      const inIndexMatches = [];
      const inMatches = [];
      let match;
      while ((match = outMatch.exec(value)) != null) {
        outIndexMatches.push({
          index: match.index,
        });
      }
      while ((match = inMatch.exec(value)) != null) {
        inIndexMatches.push({
          index: match.index,
        });
      }
      this.outputParams = [];
      outIndexMatches.forEach((itemIndex, itemPosition) => {
        const valueTemp = value.substring(itemIndex.index, value.length);
        let endIndex = valueTemp.indexOf(" ");
        const paramTemp = valueTemp.substring(0, endIndex);
        const paramName = paramTemp.split(":")[1];
        let param = {
          index: itemPosition,
          name: paramName,
        };
        this.addOutputParam(param);
      });

      this.inputParams = [];
      inIndexMatches.forEach((itemIndex, itemPosition) => {
        const valueTemp = value.substring(itemIndex.index, value.length);
        let endIndex = valueTemp.indexOf(" ");
        const paramTemp = valueTemp.substring(0, endIndex);
        const paramName = paramTemp.split(":")[1];
        let param = {
          index: itemPosition,
          name: paramName,
        };
        this.addInputParam(param);
      });
    },
    deleteInputParam(item) {
      const index = this.inputParams.indexOf(item);
      this.inputParams.splice(index, 1);
    },
    deleteOutputParam(item) {
      const index = this.outputParams.indexOf(item);
      this.outputParams.splice(index, 1);
    },
    addInputParam(param) {
      this.defaultInputParam.index = param.index;
      this.defaultInputParam.orden = param.index;
      this.defaultInputParam.name = param.name;
      this.inputParams.push(JSON.parse(JSON.stringify(this.defaultInputParam)));
    },
    addOutputParam(param) {
      this.defaultOutputParam.index = param.index;
      this.defaultOutputParam.orden = param.index;
      this.defaultOutputParam.name = param.name;
      this.outputParams.push(
        JSON.parse(JSON.stringify(this.defaultOutputParam))
      );
    },
    mergeParams() {
      this.inoutParams = [];
      let inputParams = JSON.parse(JSON.stringify(this.inputParams));
      let outputParams = JSON.parse(JSON.stringify(this.outputParams));
      inputParams.sort((a, b) => a.orden - b.orden);
      outputParams.sort((a, b) => a.orden - b.orden);
      inputParams.forEach((item) => {
        delete item.orden;
        delete item.index;
        this.inoutParams.push(item);
      });
      outputParams.forEach((item) => {
        delete item.orden;
        delete item.index;
        this.inoutParams.push(item);
      });
      this.itemTab.setParams(this.inoutParams, this.itemTab);
    },
  },
  beforeMount() {
    this.extractParamsFromInput();
  },
};
</script>
